/*
====================
		EXAMPLE SCRIPT FOR EVENTS AND STORYLINES
		Vincent Beers, 2005
		http://DaVince.websitemaster.org/
		http://DaVince.sitesled.com/
		Email: VincentBeers@yahoo.com
		
		This tutorial shows how to implement events and storylines.
		The example uses only one function for events, Event(), but you can split this up if
		you'd like (Event(), Story(), ExtraEvent()...).
*/

//Let's add a new script for all our story needs.
//Look in Story.js and the map entities to see how things are done. Nifty huh?
RequireScript("Story.js");

//The variable font is put here for easyness. :)
var font = GetSystemFont();


//Start function.
function game()
{
	CreatePerson("person", "ball.rss", false);
	AttachInput("person");
	AttachCamera("person");

	var Music = LoadSound("OpenPod.mid");
	Music.play(true);

	MapEngine("ExampleMap.rmp", 60);
}


//========================
//		A TEXTBOX
//========================

function TextBox(text)
{
	//While the space key IS pressed, wait until it's released.
  while (IsKeyPressed(KEY_SPACE));
  
  var windowstyle = GetSystemWindowStyle();
  var x = 16;
  var y = 16;
  var width = GetScreenWidth() - 32;
  var height = font.getStringHeight(text, width);
  
  if (IsMapEngineRunning() == true)
  {
	RenderMap();
  }
  
  windowstyle.drawWindow(x, y, width, height);
  font.drawTextBox(x, y, width, height, 0, text);
  FlipScreen();
  
  while (!IsKeyPressed(KEY_SPACE));
  while (IsKeyPressed(KEY_SPACE));
}



//This will be pretty clear if you read the previous stuff.
function Warp(map, x, y)
{
	//We will call our custom function, FadeOut here! With a parameter!
	FadeOut(3);

	ChangeMap(map);
	SetPersonX("person", x * 16 + 5);
	SetPersonY("person", y * 16 + 5);
	//The + 5 is to set the position a bit more correctly. Remove it to see what I mean! ;)

	//And our other function, FadeIn.
	FadeIn(3);
}



function FadeOut(speed)
{
	var i = 0;
	var FadeColor;

	//GetScreenHeight() and GetScreenWidth() get your screen's height and width.
	var SW = GetScreenWidth();
	var SH = GetScreenHeight();

	//GrabImage takes your screen and puts it in the variable ScreenImage.
	//GrabImage(x, y, width, height);
	var ScreenImage = GrabImage(0,0, SW, SH);

	//Let's render the map again BEFORE fading in to remove bugs.
	if (IsMapEngineRunning())
	{
		RenderMap();
	}

	for (i = 0; i < 255; i+=speed)
	{
	
		if (IsMapEngineRunning())
		{
			RenderMap();
		}
		FadeColor = CreateColor(0, 0, 0, i);
	
		//Let's blit our screen image now. With a color mask over it: our FadeColor.
		ScreenImage.blitMask(0,0, FadeColor);
		FlipScreen();
	}
}


function FadeIn(speed, R, G, B)
{
	var i = 255;
	var FadeColor;
	var SW = GetScreenWidth();
	var SH = GetScreenHeight();

	var Surface = GrabSurface(0,0,GetScreenWidth(),GetScreenHeight());
	var SurfaceImage = Surface.createImage();

	for (i = 255; i > 0; i-=speed)
	{
		//The same code as the fade out, but reversed! i gets less now instead of more.
		if (IsMapEngineRunning())
		{
			RenderMap();
		}

		FadeColor = CreateColor(0, 0, 0, i);
		SurfaceImage.blitMask(0,0, FadeColor);
		FlipScreen();
	}
}


function Delay(milliseconds)
{
  var start = GetTime();
  while (start + milliseconds > GetTime())
  {
  }
}
