//Story.js

//A new var. This one will regulate a 'story'.
//We set it to false because that's easiest for most simple events: Has the player done something yes or no?
var StoryDoorOpen = false;



//This function is called from the green person and is just really a shortcut to keep as much code as possible in the scripts.
function Event(event)
{

	/*The events are called as follows:
	1. When you talk to someone or walk somewhere, Event() is started with as parameter a specific string.
	2. This function, Event(), looks at what the string is and starts the right event. So if you inserted "TalkToGreen" as
			event, this gets started. This makes things easier, because numbers or all seperate functions are not handy and
			take up more memory.
			If the parameter string does not exist, nothing will happen.
	3. Inside the specific event, things like variable changing may happen so you can continue the game (like, var Door1
			is changed, so another event which looks up door1 will act differently, like being able to use the door).
	
	If things are still not clear, just go look through the code now.
	*/
	
	//New event
	if (event == "TalkToGreen")
	{
		//Let's now check the story stats.
		if (StoryDoorOpen == false)
		{
			//The \n in that textbox means "New Line" and the \t means "add a tab".
			TextBox("\tGreen person\nHello. What is it?");
			TextBox("\tMain person\nI'm trying to open that door but it's locked...");
			TextBox("\tGreen person\nNo problem. I'll unlock it for you.");
			TextBox("\tMain person\nThanks.");
			
			//Let's make our event StoryDoorOpen true now.
			StoryDoorOpen = true;
			//This is proof that we talked to the green person!
		}
		
		//Now what if we talked to the green person while our event was already true (or at least different from false)?
		//The else is to prevent that things get screwed up. It will only start if the previous if wasn't started, see,
		//and as this is right after StoryDoorOpen was turned to true, this would start right away if an if instead of an else
		//was used. You can also use "else if()" if you still have conditions.
		else
		{
			TextBox("\tGreen person\nI unlocked that door for you, remember?");
			TextBox("\tMain person\nYes. I'm very grateful for that.");
		}
	//We	have coded our event "StoryDoorOpen", now let's close that if and let's go to the next if.
	//Before using this }, you can type other stuff here which will happen globally, wheter some variable is true or not.
	}
	
	
	//Another event. Remember that this if is with the (event=="") and not with the (StoryDoorOpen)!
	else if (event == "TryToOpenDoor")
	{
		//Let's check if our StoryDoorOpen is true or not.
		if (StoryDoorOpen == false)		//You can also start the other way around, with true, if you want.
		{
			TextBox("The door is locked... Hmm...");
			TextBox("Someone might be able to help me. Maybe that Green person over there?");
			
			//Just a command to let the person move south for a bit...
			QueuePersonCommand("person",COMMAND_MOVE_SOUTH,true);
			
			//No changes in events in this one...
		}
		
		else
		{
			TextBox("Hey, the door is open!");
			Warp("ExampleMap.rmp", 3, 10);
			
			//Hee!
			TextBox("Huh? I'm outside again... Weird.");
		}
	}
	
//When all events are done, we can finally close down our function.
//As you can see it can become VERY big, so you may consider splitting it up into more functions.
//You can type Global stuff here for all events to happen. It's useful for debugging, but not recommended.
Delay(500);
font.setColorMask(CreateColor(50, 255, 255));
TextBox("The event " + event + " has happened! ^_^");
font.setColorMask(CreateColor(255, 255, 255));
}
